#include "HorizontalSpacer.h"

#include <algorithm>

HorizontalSpacer::HorizontalSpacer()
    : Widget()
{

}

std::unique_ptr<HorizontalSpacer> HorizontalSpacer::Create()
{
    return std::make_unique<HorizontalSpacer>();
}

void HorizontalSpacer::AddChildLayers(const PaintEvent* event)
{
    mLayers.clear();
    unsigned delta = mHeight / mChildren.size();
    for(std::size_t idx=0; idx<mChildren.size(); idx++)
    {
        auto& child = mChildren[idx];
        child->SetSize(mWidth, delta);
        child->SetLocation(DiscretePoint(mLocation.GetX(), mLocation.GetY() + delta*idx));
        child->OnPaintEvent(event);
        auto layers = child->GetLayers();
        mLayers.insert(mLayers.end(), layers.begin(), layers.end());
    }
}

void HorizontalSpacer::OnPaintEvent(const PaintEvent* event)
{
    AddChildLayers(event);
}
