#include "TextElement.h"

TextElement::TextElement(const std::string& content, const DiscretePoint& loc)
    : mContent(content),
      mLocation(loc),
      mFontLabel("fixed")
{

}

TextElement::~TextElement()
{

}

std::unique_ptr<TextElement> TextElement::Create(const std::string& content, const DiscretePoint& loc)
{
    return std::make_unique<TextElement>(content, loc);
}

DiscretePoint TextElement::GetLocation() const
{
    return mLocation;
}

std::string TextElement::GetFontLabel() const
{
    return mFontLabel;
}

std::string TextElement::GetContent() const
{
    return mContent;
}

void TextElement::SetContent(const std::string& content)
{
    mContent = content;
}
